create or replace package XXSLA_REPORT_PKG is

  -- Author  : assortix.ru (scmconsult@mail.ru)
  -- Created : 
  -- Purpose :  ( ).   .    
  
  -- Public constant declarations
  g_application_id constant number(10) := 0;

  function get_cond(p_application_id number
           	     , p_amb_context_code varchar2
                 , p_entity_code varchar2   
                 , p_event_class_code varchar2
                 , p_accounting_line_code varchar2
                 ) return varchar2;

end XXSLA_REPORT_PKG;
/
create or replace package body XXSLA_REPORT_PKG is

       
  function get_cond(p_application_id number
           	     , p_amb_context_code varchar2
                 , p_entity_code varchar2   
                 , p_event_class_code varchar2
                 , p_accounting_line_code varchar2
                 ) return varchar2 as
    p_string varchar2(2000); 
   begin
    
    for c in (
      select cond.source_code, DECODE(cond.LINE_OPERATOR_CODE,'D','!=','E','=') as line_operator_code, cond.value_constant 
      
             , DECODE(cond.LOGICAL_OPERATOR_CODE,'A','','O','') as LOGICAL_OPERATOR 
      
             from XLA.XLA_CONDITIONS cond where 1=1 
                and cond.application_id = p_application_id  
                and cond.amb_context_code = p_amb_context_code
                and p_entity_code = cond.entity_code
                and p_event_class_code = cond.event_class_code
                 
                and p_accounting_line_code = cond.accounting_line_code
                
                order by cond.user_sequence
    ) loop
                    
      p_string :=  nvl(p_string, ' ') || c.source_code || ' ' || c.line_operator_code || ' ' || c.value_constant || ' ' || c.LOGICAL_OPERATOR || ' ';
    
    end loop;
    
        return trim(p_string);
    
  end get_cond;
  
end XXSLA_REPORT_PKG;
/
